diff -Narup Mtd-orig/util/compr-old.c mtd/util/compr-old.c
--- Mtd-orig/util/compr-old.c	1970-01-01 01:00:00.000000000 +0100
+++ mtd/util/compr-old.c	2005-11-28 10:19:04.000000000 +0100
@@ -0,0 +1,586 @@
+/*
+ * JFFS2 -- Journalling Flash File System, Version 2.
+ *
+ * Copyright (C) 2004 Ferenc Havasi <havasi@inf.u-szeged.hu>,
+ *                    University of Szeged, Hungary
+ *
+ * For licensing information, see the file 'LICENCE' in this directory
+ * in the jffs2 directory.
+ *
+ * $Id: compr.c,v 1.8 2005/07/26 13:07:02 havasi Exp $
+ *
+ */
+
+#include "compr-old.h"
+#include <string.h>
+#include <stdlib.h>
+#include <linux/jffs2.h>
+
+extern int page_size;
+
+/* LIST IMPLEMENTATION (from linux/list.h) */
+
+#define LIST_HEAD_INIT(name) { &(name), &(name) }
+
+#define LIST_HEAD(name) \
+	struct list_head name = LIST_HEAD_INIT(name)
+
+static inline void __list_add(struct list_head *new,
+							  struct list_head *prev,
+							  struct list_head *next)
+{
+	next->prev = new;
+	new->next = next;
+	new->prev = prev;
+	prev->next = new;
+}
+
+static inline void list_add(struct list_head *new, struct list_head *head)
+{
+	__list_add(new, head, head->next);
+}
+
+static inline void list_add_tail(struct list_head *new, struct list_head *head)
+{
+	__list_add(new, head->prev, head);
+}
+
+static inline void __list_del(struct list_head *prev, struct list_head *next)
+{
+	next->prev = prev;
+	prev->next = next;
+}
+
+static inline void list_del(struct list_head *entry)
+{
+	__list_del(entry->prev, entry->next);
+	entry->next = (void *) 0;
+	entry->prev = (void *) 0;
+}
+
+#define list_entry(ptr, type, member) \
+	((type *)((char *)(ptr)-(unsigned long)(&((type *)0)->member)))
+
+#define list_for_each_entry(pos, head, member)					\
+	for (pos = list_entry((head)->next, typeof(*pos), member);	\
+		&pos->member != (head);									\
+		pos = list_entry(pos->member.next, typeof(*pos), member))
+
+
+/* Available compressors are on this list */
+static LIST_HEAD(jffs2_compressor_list);
+/* Compression sequence depends on the comression mode) */
+static LIST_HEAD(jffs2_compression_list);
+
+/* Actual compression mode */
+static int jffs2_compression_mode = JFFS2_COMPR_MODE_NONE;
+
+void jffs2_set_compression_mode(int mode) 
+{
+	jffs2_compression_mode = mode;
+}
+
+int jffs2_get_compression_mode(void)
+{
+	return jffs2_compression_mode;
+}
+
+/* Statistics for blocks stored without compression */
+static uint32_t none_stat_compr_blocks = 0,
+				none_stat_decompr_blocks = 0,
+				none_stat_compr_size = 0;
+
+/* Compression test stuffs */
+
+static int jffs2_compression_check = 0;
+static unsigned char *jffs2_compression_check_buf = NULL;
+
+void jffs2_compression_check_set(int yesno)
+{
+	jffs2_compression_check = yesno;
+}
+
+int jffs2_compression_check_get(void)
+{
+	return jffs2_compression_check;
+}
+
+static int jffs2_error_cnt = 0;
+
+int jffs2_compression_check_errorcnt_get(void)
+{
+	return jffs2_error_cnt;
+}
+
+#define JFFS2_BUFFER_FILL 0x55
+
+/* Called before compression (if compression_check is setted) to prepare 
+   the buffer for buffer overflow test */
+static void jffs2_decompression_test_prepare(unsigned char *buf, int size)
+{
+	memset(buf,JFFS2_BUFFER_FILL,size+1);
+}
+
+/* Called after compression (if compression_check is setted) to test the result */
+static void jffs2_decompression_test(struct jffs2_compressor *compr,
+					unsigned char *data_in, unsigned char *output_buf,
+					uint32_t cdatalen, uint32_t datalen, uint32_t buf_size)
+{
+	uint32_t i;
+
+	/* buffer overflow test */
+	for (i=buf_size;i>cdatalen;i--) {
+		if (output_buf[i]!=JFFS2_BUFFER_FILL) {
+			fprintf(stderr,"COMPR_ERROR: buffer overflow at %s. "
+					"(bs=%d csize=%d b[%d]=%d)\n", compr->name, 
+					buf_size, cdatalen, i, (int)(output_buf[i]));
+			jffs2_error_cnt++;
+			return;
+		}
+	}
+	/* allocing temporary buffer for decompression */
+	if (!jffs2_compression_check_buf) {
+		jffs2_compression_check_buf = malloc(page_size);
+		if (!jffs2_compression_check_buf) {
+			fprintf(stderr,"No memory for buffer allocation. Compression check disabled.\n");
+			jffs2_compression_check = 0;
+			return;
+		}
+	}
+	/* decompressing */
+	if (!compr->decompress) {
+		fprintf(stderr,"JFFS2 compression check: there is no decompress function at %s.\n", compr->name);
+		jffs2_error_cnt++;
+		return;
+	}
+	if (compr->decompress(output_buf,jffs2_compression_check_buf,cdatalen,datalen,NULL)) {
+		fprintf(stderr,"JFFS2 compression check: decompression failed at %s.\n", compr->name);
+		jffs2_error_cnt++;
+	}
+	/* validate decompression */
+	else {
+		for (i=0;i<datalen;i++) {
+			if (data_in[i]!=jffs2_compression_check_buf[i]) {
+				fprintf(stderr,"JFFS2 compression check: data mismatch at %s (pos %d).\n", compr->name, i);
+				jffs2_error_cnt++;
+				break;
+			}
+		}
+	}
+}
+
+/* jffs2_compress:
+ * @data: Pointer to uncompressed data
+ * @cdata: Pointer to returned pointer to buffer for compressed data
+ * @datalen: On entry, holds the amount of data available for compression.
+ *	On exit, expected to hold the amount of data actually compressed.
+ * @cdatalen: On entry, holds the amount of space available for compressed
+ *	data. On exit, expected to hold the actual size of the compressed
+ *	data.
+ *
+ * Returns: Lower byte to be stored with data indicating compression type used.
+ * Zero is used to show that the data could not be compressed - the 
+ * compressed version was actually larger than the original.
+ * Upper byte will be used later. (soon)
+ *
+ * If the cdata buffer isn't large enough to hold all the uncompressed data,
+ * jffs2_compress should compress as much as will fit, and should set 
+ * *datalen accordingly to show the amount of data which were compressed.
+ */
+uint16_t jffs2_compress( unsigned char *data_in, unsigned char **cpage_out,
+			 uint32_t *datalen, uint32_t *cdatalen)
+{
+	int ret = JFFS2_COMPR_NONE;
+	int compr_ret;
+	struct jffs2_compressor *this, *best=NULL;
+	unsigned char *output_buf = NULL, *tmp_buf;
+	uint32_t orig_slen, orig_dlen;
+	uint32_t best_slen=0, best_dlen=0;
+
+	switch (jffs2_compression_mode) {
+	case JFFS2_COMPR_MODE_NONE:
+		break;
+	case JFFS2_COMPR_MODE_FIRST:
+		orig_slen = *datalen;
+		orig_dlen = *cdatalen;
+		output_buf = malloc(orig_dlen+jffs2_compression_check);
+		if (!output_buf) {
+			fprintf(stderr,"mkfs.jffs2: No memory for compressor allocation. Compression failed.\n");
+			goto out;
+		}
+		list_for_each_entry(this, &jffs2_compression_list, cn_list) {
+			/* Skip decompress-only backwards-compatibility and disabled modules */
+			if (!this->compress)
+				continue;
+
+			this->usecount++;
+
+			if (jffs2_compression_check) /*preparing output buffer for testing buffer overflow */
+				jffs2_decompression_test_prepare(output_buf, orig_dlen);
+
+			*datalen  = orig_slen;
+			*cdatalen = orig_dlen;
+			compr_ret = this->compress(data_in, output_buf, datalen, cdatalen, NULL);
+			this->usecount--;
+			if (!compr_ret) {
+				ret = this->compr;
+				this->stat_compr_blocks++;
+				this->stat_compr_orig_size += *datalen;
+				this->stat_compr_new_size  += *cdatalen;
+				if (jffs2_compression_check)
+					jffs2_decompression_test(this, data_in, output_buf, *cdatalen, *datalen, orig_dlen);
+				break;
+			}
+		}
+		if (ret == JFFS2_COMPR_NONE)
+			free(output_buf);
+		break;
+	case JFFS2_COMPR_MODE_BEST:
+		orig_slen = *datalen;
+		orig_dlen = *cdatalen;
+		list_for_each_entry(this, &jffs2_compression_list, cn_list) {
+			/* Skip decompress-only backwards-compatibility and disabled modules */
+			if (!this->compress)
+				continue;
+			/* Allocating memory for output buffer if necessary */
+			if ((this->compr_buf_size<orig_dlen+jffs2_compression_check)&&(this->compr_buf)) {
+				free(this->compr_buf);
+				this->compr_buf_size=0;
+				this->compr_buf=NULL;
+			}
+			if (!this->compr_buf) {
+				tmp_buf = malloc(orig_dlen+jffs2_compression_check);
+				if (!tmp_buf) {
+					fprintf(stderr,"mkfs.jffs2: No memory for compressor allocation. (%d bytes)\n",orig_dlen);
+					continue;
+				}
+				else {
+					this->compr_buf = tmp_buf;
+					this->compr_buf_size = orig_dlen;
+				}
+			}
+			this->usecount++;
+			if (jffs2_compression_check) /*preparing output buffer for testing buffer overflow */
+				jffs2_decompression_test_prepare(this->compr_buf,this->compr_buf_size);
+			*datalen  = orig_slen;
+			*cdatalen = orig_dlen;
+			compr_ret = this->compress(data_in, this->compr_buf, datalen, cdatalen, NULL);
+			this->usecount--;
+			if (!compr_ret) {
+				if (jffs2_compression_check)
+					jffs2_decompression_test(this, data_in, this->compr_buf, *cdatalen, *datalen, this->compr_buf_size);
+				if ((!best_dlen)||(best_dlen>*cdatalen)) {
+					best_dlen = *cdatalen;
+					best_slen = *datalen;
+					best = this;
+				}
+			}
+		}
+		if (best_dlen) {
+			*cdatalen = best_dlen;
+			*datalen  = best_slen;
+			output_buf = best->compr_buf;
+			best->compr_buf = NULL;
+			best->compr_buf_size = 0;
+			best->stat_compr_blocks++;
+			best->stat_compr_orig_size += best_slen;
+			best->stat_compr_new_size  += best_dlen;
+			ret = best->compr;
+		}
+		break;
+	default:
+		fprintf(stderr,"mkfs.jffs2: unknow compression mode.\n");
+	}
+ out:
+	if (ret == JFFS2_COMPR_NONE) {
+		*cpage_out = data_in;
+		*datalen = *cdatalen;
+		none_stat_compr_blocks++;
+		none_stat_compr_size += *datalen;
+	}
+	else {
+		*cpage_out = output_buf;
+	}
+	return ret;
+}
+
+
+
+#define JFFS2_STAT_BUF_SIZE 16000
+
+char *jffs2_list_compressors(void)
+{
+	struct jffs2_compressor *this;
+	char *buf, *act_buf;
+
+	act_buf = buf = malloc(JFFS2_STAT_BUF_SIZE);
+	list_for_each_entry(this, &jffs2_compressor_list, list) {
+		act_buf += sprintf(act_buf, "%10s ", this->name);
+		if (!this->compress)
+			act_buf += sprintf(act_buf,"disabled");
+		else
+			act_buf += sprintf(act_buf,"enabled");
+		act_buf += sprintf(act_buf,"\n");
+	}
+	return buf;
+}
+
+char *jffs2_stats(void)
+{
+	struct jffs2_compressor *this;
+	char *buf, *act_buf;
+
+	act_buf = buf = malloc(JFFS2_STAT_BUF_SIZE);
+
+	act_buf += sprintf(act_buf,"Compression mode: ");
+	switch (jffs2_compression_mode) {
+	case JFFS2_COMPR_MODE_NONE:
+		act_buf += sprintf(act_buf,"none");
+		break;
+	case JFFS2_COMPR_MODE_FIRST:
+		act_buf += sprintf(act_buf,"first");
+		break;
+	case JFFS2_COMPR_MODE_BEST:
+		act_buf += sprintf(act_buf,"best");
+		break;
+	default:
+		act_buf += sprintf(act_buf,"unkown");
+		break;
+	}
+	act_buf += sprintf(act_buf,"\nCompressors:\n");
+	act_buf += sprintf(act_buf,"%10s	     ","none");
+	act_buf += sprintf(act_buf,"compr: %d blocks (%d)  decompr: %d blocks\n", none_stat_compr_blocks,
+						none_stat_compr_size, none_stat_decompr_blocks);
+	list_for_each_entry(this, &jffs2_compressor_list, list) {
+		act_buf += sprintf(act_buf,"%10s ",this->name);
+		if (!this->compress)
+			act_buf += sprintf(act_buf,"- ");
+		else
+			act_buf += sprintf(act_buf,"+ ");
+		act_buf += sprintf(act_buf,"compr: %d blocks (%d/%d)  decompr: %d blocks ", this->stat_compr_blocks,
+							this->stat_compr_new_size, this->stat_compr_orig_size,
+							this->stat_decompr_blocks);
+		act_buf += sprintf(act_buf,"\n");
+	}
+	return buf;
+}
+
+static char *jffs2_strcpy_skp_ws(char *in)
+{
+	int i, len;
+	char *new, *tmp_ptr;
+
+	if (!in)
+		return NULL;
+
+	len = strlen(in);
+	new = malloc(len + 1);
+	if (!new)
+		return NULL;
+	tmp_ptr = new;
+
+	for(i=0; i<len; i++) {
+		if (in[i] != ' ' && in[i] != '\t' && in[i] != '\n') {
+			*tmp_ptr = in[i];
+			tmp_ptr++;
+		}
+	}
+	tmp_ptr = '\0';
+
+	len = strlen(new);
+	if (!len) {
+		free(new);
+		return NULL;
+	}
+
+	return new;
+}
+
+int jffs2_register_compressor(struct jffs2_compressor *comp)
+{
+	if (!comp->name) {
+		fprintf(stderr,"NULL compressor name at registering JFFS2 compressor. Failed.\n");
+		return -1;
+	}
+	comp->compr_buf_size=0;
+	comp->compr_buf=NULL;
+	comp->usecount=0;
+	comp->stat_compr_orig_size=0;
+	comp->stat_compr_new_size=0;
+	comp->stat_compr_blocks=0;
+	comp->stat_decompr_blocks=0;
+	list_add_tail(&comp->list, &jffs2_compressor_list);
+
+	return 0;
+}
+
+int jffs2_unregister_compressor(struct jffs2_compressor *comp)
+{
+
+	if (comp->usecount) {
+		fprintf(stderr,"mkfs.jffs2: Compressor modul is in use. Unregister failed.\n");
+		return -1;
+	}
+	list_del(&comp->list);
+
+	return 0;
+}
+
+
+
+/* returns 1 if the selected compressor (compr) is on the comression list, 0 otherwise */
+static int jffs2_is_compr_on_compression_list(struct jffs2_compressor *compr)
+{
+	struct jffs2_compressor *this;
+
+	list_for_each_entry(this, &jffs2_compression_list, cn_list) {
+		if (this == compr) {
+			fprintf(stderr,"Compressor (%s) is already on compression list!\n(It can be on the list only once!)\n",compr->name);
+			return 1;
+		}
+	}
+
+	return 0;
+}
+
+static int jffs2_add_compr_to_compression_list(char *name)
+{
+	struct jffs2_compressor *this;
+	int ret;
+
+	list_for_each_entry(this, &jffs2_compressor_list, list) {
+		if (!strcmp(this->name, name)) {
+
+			ret = jffs2_is_compr_on_compression_list(this);
+			if (ret)
+				return ret;
+
+			list_add_tail(&this->cn_list,&jffs2_compression_list);
+			return 0;
+		}
+	}
+	fprintf(stderr,"Compressor (%s) not found.\n",name);
+	return 1;
+}
+
+int jffs2_setup_compression(char *compr_cont)
+{
+	char *data, *from, *to, *iter;
+	char* cmpr_name = NULL;
+	int mode, run, ret;
+	int len, flag = 0;
+
+	data = jffs2_strcpy_skp_ws(compr_cont);
+	if (!data)
+		return -1;
+
+	printf("Compression control string: %s\n",data);
+
+	iter = data;
+	from = to = data;
+	mode = JFFS2_COMPR_MODE_NONE;
+	run = 1;
+	while (run) {
+		switch(*iter) {
+			case '{' :
+			case '[' :
+				if (mode || flag) {
+					fprintf(stdout,"Compression control string parse error!\n");
+					goto error;
+				}
+
+				if (*iter == '{')
+					mode = JFFS2_COMPR_MODE_BEST;
+				else {
+					mode = JFFS2_COMPR_MODE_FIRST;
+				}
+
+				from = iter + 1;
+				break;
+
+			case '}' :
+			case ']' :
+			case ',' :
+			case '\0' :
+				if (from == to) {
+					fprintf(stderr,"Compressor name with length 0 is not allowed!\n");
+					goto error;
+				}
+
+				if (*iter == ',' && flag == 1) {
+					fprintf(stderr,"Comma is allowed only between {} or []\n");
+					goto error;
+				}
+
+				if (*iter == '\0' && mode != 0 && !(*(iter-1) == '}' || *(iter-1) == ']')) {
+					fprintf(stderr,"Compression control string contains not determinated expression ({} or [])!\n");
+					goto error;
+				}
+
+				if (*iter == '\0' || *iter == ']' || *iter == '}')
+					run = 0;
+
+				len = to - from;
+
+				cmpr_name = malloc(len + 1);
+				if (!cmpr_name) {
+					fprintf(stderr,"Memory allocation error!\n");
+					goto error;
+				}
+
+				strncpy(cmpr_name, from, len);
+				cmpr_name[len] = '\0';
+
+				ret = jffs2_add_compr_to_compression_list(cmpr_name);
+				if (ret) 
+					goto error;
+
+				free(cmpr_name);
+				from = to = iter + 1;
+				break;
+
+			default :
+				to = iter + 1;
+				if (mode == JFFS2_COMPR_MODE_NONE) {
+					flag = 1;
+				}
+				break;
+		}
+		iter++;
+	}
+
+	if (flag)
+		mode = JFFS2_COMPR_MODE_FIRST;
+
+	jffs2_set_compression_mode(mode);
+	//printf("Compression mode is : %d\n", mode);
+
+	free(data);
+	return 0;
+
+ error:
+	free(data);
+	return -1;
+}
+
+int jffs2_compressors_init(void)
+{
+#ifdef CONFIG_JFFS2_ZLIB
+	jffs2_zlib_init();
+#endif
+#ifdef CONFIG_JFFS2_RTIME
+	jffs2_rtime_init();
+#endif
+	return 0;
+}
+
+int jffs2_compressors_exit(void)
+{
+#ifdef CONFIG_JFFS2_RTIME
+	jffs2_rtime_exit();
+#endif
+#ifdef CONFIG_JFFS2_ZLIB
+	jffs2_zlib_exit();
+#endif
+	return 0;
+}
diff -Narup Mtd-orig/util/compr-old.h mtd/util/compr-old.h
--- Mtd-orig/util/compr-old.h	1970-01-01 01:00:00.000000000 +0100
+++ mtd/util/compr-old.h	2005-11-28 10:19:04.000000000 +0100
@@ -0,0 +1,106 @@
+/*
+ * JFFS2 -- Journalling Flash File System, Version 2.
+ *
+ * Copyright (C) 2004 Ferenc Havasi <havasi@inf.u-szeged.hu>,
+ *                    University of Szeged, Hungary
+ *
+ * For licensing information, see the file 'LICENCE' in the 
+ * jffs2 directory.
+ *
+ * $Id: compr.h,v 1.6 2005/07/26 13:07:02 havasi Exp $
+ *
+ */
+
+#ifndef __JFFS2_COMPR_H__
+#define __JFFS2_COMPR_H__
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <stdint.h>
+
+#define CONFIG_JFFS2_COMPR_COMPAT
+#include "linux/jffs2.h"
+
+#define CONFIG_JFFS2_ZLIB
+#define CONFIG_JFFS2_RTIME
+
+#define JFFS2_COMPR_MODE_NONE		0
+#define JFFS2_COMPR_MODE_FIRST		1
+#define JFFS2_COMPR_MODE_BEST		2
+
+#define kmalloc(a,b)                malloc(a)
+#define kfree(a)                    free(a)
+#ifndef GFP_KERNEL
+#define GFP_KERNEL                  0
+#endif
+
+#define vmalloc(a)                  malloc(a)
+#define vfree(a)                    free(a)
+
+#define printk(...)                 fprintf(stderr,__VA_ARGS__)
+
+#define KERN_EMERG
+#define KERN_ALERT
+#define KERN_CRIT
+#define KERN_ERR
+#define KERN_WARNING
+#define KERN_NOTICE
+#define KERN_INFO
+#define KERN_DEBUG
+
+struct list_head {
+        struct list_head *next, *prev;
+};
+
+void jffs2_set_compression_mode(int mode);
+int jffs2_get_compression_mode(void);
+int jffs2_set_compression_mode_name(const char *mode_name);
+
+struct jffs2_compressor {
+	struct list_head list;		/* for compressors list */
+	struct list_head cn_list;	/* for compression lint */
+	char *name;
+	char compr;					/* JFFS2_COMPR_XXX */
+	int (*compress)(unsigned char *data_in, unsigned char *cpage_out,
+					uint32_t *srclen, uint32_t *destlen, void *model);
+	int (*decompress)(unsigned char *cdata_in, unsigned char *data_out,
+						uint32_t cdatalen, uint32_t datalen, void *model);
+	int usecount;
+	unsigned char *compr_buf;	/* used by size compr. mode */
+	uint32_t compr_buf_size;	/* used by size compr. mode */
+	uint32_t stat_compr_orig_size;
+	uint32_t stat_compr_new_size;
+	uint32_t stat_compr_blocks;
+	uint32_t stat_decompr_blocks;
+};
+
+int jffs2_register_compressor(struct jffs2_compressor *comp);
+int jffs2_unregister_compressor(struct jffs2_compressor *comp);
+
+int jffs2_compressors_init(void);
+int jffs2_compressors_exit(void);
+int jffs2_setup_compression(char *comp_str);
+
+uint16_t jffs2_compress(unsigned char *data_in, unsigned char **cpage_out,
+							uint32_t *datalen, uint32_t *cdatalen);
+
+/* If it is setted, a decompress will be called after every compress */
+void jffs2_compression_check_set(int yesno);
+int jffs2_compression_check_get(void);
+int jffs2_compression_check_errorcnt_get(void);
+
+char *jffs2_list_compressors(void);
+char *jffs2_stats(void);
+
+/* Compressor modules */
+/* These functions will be called by jffs2_compressors_init/exit */
+#ifdef CONFIG_JFFS2_ZLIB
+int jffs2_zlib_init(void);
+void jffs2_zlib_exit(void);
+#endif
+#ifdef CONFIG_JFFS2_RTIME
+int jffs2_rtime_init(void);
+void jffs2_rtime_exit(void);
+#endif
+
+#endif /* __JFFS2_COMPR_H__ */
